---
name: Bug Report
about: Create a bug report for a new issue
title: Give your bug report a descriptive title
labels: ':beetle: bug'
assignees: ''

---
<!-- Please verify this bug has not already been reported: https://github.com/OpenShot/openshot-qt/issues -->

**Describe the bug:**
A clear and concise description of what the bug is.

**Steps to reproduce the behavior:**
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Expected behavior:**
A clear and concise description of what you expected to happen.

**System Details:**
- OpenShot Version [e.g. 2.4.3]: {{ log_context.openshot_qt_version }}
- Operating System / Distro: [e.g. Windows 10, Linux Mint 17.1]

**Log Files:**
If you are experiencing a crash, please collect and attach logs of the problem.
Log files can be found in your HOME/.openshot_qt/ folder. Please compress or zip
the log files (as they can become quite large).

**Exception / Stacktrace:**
If you are experiencing a crash or strange output on the command line, please
attach a small snippet of the exception here, but please keep it as small as
possible (for readability).

**Screenshots:** (Optional)
If applicable, add screenshots to help explain your problem. You can include screenshots by
copy/pasting them here, dragging-and-dropping into this form, or clicking below and loading
images saved to your computer. All images are public, so please don't post screenshots
containing personal information.
